/*----- PROTECTED REGION ID(E2SextupoleStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        E2SextupoleStateMachine.cpp
//
// description : State machine file for the E2Sextupole class
//
// project :     Elettra 2.0 pure corrector magnet device
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Elettra - Sincrotrone Trieste S.c.p.A.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "E2Sextupole.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2Sextupole::E2SextupoleStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  FAULT    |  at least one connected power supplies in fault
//  INIT     |  initializing system
//  OFF      |  at least one power supply OFF
//  ON       |  power supplies all ON
//  UNKNOWN  |  initialization failed


namespace E2Sextupole_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Strength_allowed()
 *	Description: Execution allowed for Strength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Strength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Strength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::StrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::StrengthStateAllowed_WRITE

	//	Not any excluded states for Strength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::StrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::StrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CorrectionStrength_allowed()
 *	Description: Execution allowed for CorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ResonanceStrength_allowed()
 *	Description: Execution allowed for ResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::ResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for ResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::ResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Current_allowed()
 *	Description: Execution allowed for Current attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Current_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Current attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CurrentStateAllowed_WRITE

	//	Not any excluded states for Current attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_BeamEnergy_allowed()
 *	Description: Execution allowed for BeamEnergy attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_BeamEnergy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BeamEnergy attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::BeamEnergyStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::BeamEnergyStateAllowed_WRITE

	//	Not any excluded states for BeamEnergy attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::BeamEnergyStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::BeamEnergyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_DesignStrength_allowed()
 *	Description: Execution allowed for DesignStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_DesignStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::INIT)
		{
		/*----- PROTECTED REGION ID(E2Sextupole::DesignStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::DesignStrengthStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for DesignStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::DesignStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::DesignStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_bbaEnable_allowed()
 *	Description: Execution allowed for bbaEnable attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_bbaEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for bbaEnable attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::bbaEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::bbaEnableStateAllowed_WRITE

	//	Not any excluded states for bbaEnable attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::bbaEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::bbaEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEHStrength_allowed()
 *	Description: Execution allowed for CEHStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEHStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEHStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHStrengthStateAllowed_WRITE

	//	Not any excluded states for CEHStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEHCorrectionStrength_allowed()
 *	Description: Execution allowed for CEHCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEHCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEHCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CEHCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEHResonanceStrength_allowed()
 *	Description: Execution allowed for CEHResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEHResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEHResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for CEHResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEVStrength_allowed()
 *	Description: Execution allowed for CEVStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEVStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEVStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVStrengthStateAllowed_WRITE

	//	Not any excluded states for CEVStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEVCorrectionStrength_allowed()
 *	Description: Execution allowed for CEVCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEVCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEVCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CEVCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEVResonanceStrength_allowed()
 *	Description: Execution allowed for CEVResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEVResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEVResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for CEVResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQStrength_allowed()
 *	Description: Execution allowed for SQStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQStrengthStateAllowed_WRITE

	//	Not any excluded states for SQStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQCorrectionStrength_allowed()
 *	Description: Execution allowed for SQCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for SQCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQResonanceStrength_allowed()
 *	Description: Execution allowed for SQResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for SQResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEHCurrent_allowed()
 *	Description: Execution allowed for CEHCurrent attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEHCurrent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEHCurrent attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHCurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHCurrentStateAllowed_WRITE

	//	Not any excluded states for CEHCurrent attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEHCurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEHCurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CEVCurrent_allowed()
 *	Description: Execution allowed for CEVCurrent attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CEVCurrent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CEVCurrent attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVCurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVCurrentStateAllowed_WRITE

	//	Not any excluded states for CEVCurrent attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CEVCurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CEVCurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_PolynomA_allowed()
 *	Description: Execution allowed for PolynomA attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_PolynomA_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PolynomA attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::PolynomAStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::PolynomAStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_PolynomB_allowed()
 *	Description: Execution allowed for PolynomB attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_PolynomB_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PolynomB attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::PolynomBStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::PolynomBStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(E2Sextupole::ResetStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ResetResonanceStrength_allowed()
 *	Description: Execution allowed for ResetResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ResetResonanceStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetResonanceStrength command.
	/*----- PROTECTED REGION ID(E2Sextupole::ResetResonanceStrengthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResetResonanceStrengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ApplyDesignStrength_allowed()
 *	Description: Execution allowed for ApplyDesignStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ApplyDesignStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ApplyDesignStrength command.
	/*----- PROTECTED REGION ID(E2Sextupole::ApplyDesignStrengthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ApplyDesignStrengthStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(E2Sextupole::E2SextupoleStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2Sextupole::E2SextupoleStateAllowed.AdditionalMethods

}	//	End of namespace
